/*
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is Mozilla Communicator client code, released
# March 31, 1998.
#
# The Initial Developer of the Original Code is
# Netscape Communications Corporation.
# Portions created by the Initial Developer are Copyright (C) 1998-1999
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#   Markus Hossner <markushossner@gmx.de>
#   Mark Banner <bugzilla@standard8.plus.com>
#   David Ascher <dascher@mozillamessaging.com>
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
*/

function initCustomization() {
  var toolbox = document.getElementById("header-view-toolbox");
  toolbox.customizeDone = function(aEvent) {
    MailToolboxCustomizeDone(aEvent, "CustomizeHeaderToolbar");
    CHTUpdateReplyButton();
  };
  var toolbarset = toolbox.ownerDocument.getElementById('customToolbars');
  toolbox.toolbarset = toolbarset;
}

function CHTOnLoadMsgHeaderPane() {
  gMessageListeners.push(CHTMessageListener);
  initCustomization();
}

function CHTOnUnloadMsgHeaderPane()
{
  Components.classes["@mozilla.org/abmanager;1"]
            .getService(Components.interfaces.nsIAbManager)
            .removeAddressBookListener(coheAddressBookListener);
  
  removeEventListener('messagepane-loaded', CHTOnLoadMsgHeaderPane, true);
  removeEventListener('messagepane-unloaded', CHTOnUnloadMsgHeaderPane, true);
}

addEventListener('messagepane-loaded', CHTOnLoadMsgHeaderPane, true);
addEventListener('messagepane-unloaded', CHTOnUnloadMsgHeaderPane, true);

function CHTUpdateReplyButton() {
  let showReplyAll = IsReplyAllEnabled();
  let showReplyList = IsReplyListEnabled();

  // If we're in a news item, we should default to Reply.
  if (gFolderDisplay.selectedMessageIsNews)
  {
    showReplyAll = false;
    showReplyList = false;
  }

  let buttonToShow = "reply";
  if (showReplyList)
    buttonToShow = "replyList";
  else if (showReplyAll)
    buttonToShow = "replyAll";

  let smartReplyButton     = document.getElementById("hdrSmartReplyButton");
  let replyButton          = document.getElementById("hdrSReplyButton");
  let replyAllButton       = document.getElementById("hdrSReplyAllButton");
  let replyListButton      = document.getElementById("hdrSReplyListButton");
  let replyAllSubButton    = document.getElementById("hdrReplyAllSubButton");
  let replyAllSubButtonSep = document.getElementById("hdrReplyAllSubButtonSep");
  let replyToSenderButton  = document.getElementById("hdrReplyToSenderButton");

  if (smartReplyButton)
  {
    /* Cleanup after customization dialog */
    replyButton.removeAttribute("disabled");
    replyAllButton.removeAttribute("disabled");
    replyListButton.removeAttribute("disabled");
    
    replyButton.hidden = (buttonToShow != "reply");
    replyAllButton.hidden = (buttonToShow != "replyAll");
    replyListButton.hidden = (buttonToShow != "replyList");
    if (gFolderDisplay.selectedMessageIsNews)
    {
      // If it's a news item, show the ReplyAll sub-button and separator.
      replyAllSubButton.hidden = false;
      replyAllSubButtonSep.hidden = false;
     }
    else if (gFolderDisplay.selectedMessageIsFeed)
    {
      // otherwise, if it's an rss item, hide all the Reply buttons.
      replyButton.hidden = true;
      replyAllButton.hidden = true;
      replyListButton.hidden = true;
      replyAllSubButton.hidden = true;
      replyAllSubButtonSep.hidden = true;
    }
    else
    {
      // otherwise, hide the ReplyAll sub-buttons.
      replyAllSubButton.hidden = true;
      replyAllSubButtonSep.hidden = true;
    }
  }
  
  if (replyToSenderButton)
  {
    if (gFolderDisplay.selectedMessageIsFeed)
      replyToSenderButton.hidden = true;
    else
      replyToSenderButton.hidden = (replyButton && !replyButton.hidden);
  }
}

var CHTMessageListener = 
{
  onStartHeaders: 
  function cML_onStartHeaders () {},

	onEndHeaders: 
  function cML_onEndHeaders() {
    CHTUpdateReplyButton();
  }
};
